import { AbstractOutputComponent, AbstractOutputProps, AbstractOutputState } from './abstract-output-component';
import * as React from 'react';
import { ColDef } from 'ag-grid-community';
import { OutputDescriptor } from 'tsp-typescript-client';
declare type TableOuputState = AbstractOutputState & {
    tableColumns: ColDef[];
    showToggleColumns: boolean;
    tableSize: number;
    pagination: boolean;
    paginationTotalPages: number;
};
declare type TableOutputProps = AbstractOutputProps & {
    cacheBlockSize?: number;
    maxBlocksInCache?: number;
    columnWidth?: number;
    blockLoadDebounce?: number;
    tableHeight?: string;
    tableWidth?: string;
};
export declare class TableOutputComponent extends AbstractOutputComponent<TableOutputProps, TableOuputState> {
    private debugMode;
    private columnIds;
    private fetchColumns;
    private columnArray;
    private paginationPageSize;
    private showIndexColumn;
    private frameworkComponents;
    private gridApi;
    private gridMatched;
    private gridRedrawn;
    private gridSearched;
    private columnApi;
    private prevStartTimestamp;
    private startTimestamp;
    private endTimestamp;
    private columnsPacked;
    private timestampCol;
    private eventSignal;
    private enableIndexSelection;
    private selectStartIndex;
    private selectEndIndex;
    private filterModel;
    private dataSource;
    private onOutputDataChanged;
    static defaultProps: Partial<TableOutputProps>;
    constructor(props: TableOutputProps);
    protected addToggleColumnsOption(arg?: () => unknown): void;
    private toggleToggleColumns;
    renderMainArea(): React.ReactNode;
    resultsAreEmpty(): boolean;
    componentDidMount(): void;
    componentWillUnmount(): void;
    doHandleOutputDataChangedSignal(outputs: OutputDescriptor[]): void;
    private checkFocus;
    setFocus(): void;
    componentDidUpdate(prevProps: TableOutputProps, _prevState: TableOuputState): Promise<void>;
    private onEventClick;
    private fetchItemProperties;
    private onKeyDown;
    private onGridReady;
    private init;
    private handleRowSelectionChange;
    private handleSelectionRangeUpdate;
    private handleTimeSelectionChange;
    private fetchTableIndex;
    private fetchAdditionalParams;
    private fetchTableLines;
    private modelToRow;
    private onModelUpdated;
    private searchEvents;
    private findMatchIndex;
    private findMatchedEvent;
    private isValidRowSelection;
    private selectRows;
    private toggleColumnVisibility;
    private updatePageIndex;
}
export {};
//# sourceMappingURL=table-output-component.d.ts.map